﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Runtime.InteropServices;
using System.Windows.Interop;
using System.ComponentModel;

namespace WpfApplication1
{
	/// <summary>
	/// MainWindow.xaml の相互作用ロジック
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow ()
		{
			InitializeComponent();
		}

		private void window_SizeChanged(object sender, System.Windows.SizeChangedEventArgs e)
		{
			// TODO: ここにイベント ハンドラーのコードを追加します。
			SetWindowSize();
		}

		private void window_Initialized(object sender, System.EventArgs e)
		{
			// TODO: ここにイベント ハンドラーのコードを追加します。
			SetWindowSize();
		}

		[StructLayout(LayoutKind.Sequential, Pack=1)]
		private struct RECT
		{
			public int left;
			public int top;
			public int right;
			public int bottom;
		}

		[DllImport("user32", CharSet = CharSet.None, ExactSpelling = true, SetLastError = true)]
		[return: MarshalAs(UnmanagedType.Bool)]
		private static extern bool GetWindowRect ([In] IntPtr hWnd, [Out] out RECT lpRect);

		private void SetWindowSize ()
		{
			var helper = new WindowInteropHelper(this);
			var handle = helper.Handle;
			RECT r;
			if (GetWindowRect(handle, out r))
			{
				Win32Height.Text = (r.bottom - r.top).ToString();
				Win32Width.Text = (r.right - r.left).ToString();
			}
			else
			{
				var lastError = Marshal.GetLastWin32Error();
				Win32Width.Text = String.Format("Error: {0}", lastError);
				var e = new Win32Exception(lastError);
				Win32Height.Text = e.Message;
			}
		}
	}
}
